

/**
 * 来自方片的添加
 */
zss_editor = {};









/**
 * --------- 来自方片收集的添加 ----------
 * 
 */
//编辑器body选择器
var _EDITOR_BODY = "div[data-editor='funpin-editor-body']";


zss_editor.triggerEvent = function(eventName,data){
    var $editor = $(_EDITOR_BODY);
    
    if(eventName){
        $editor.trigger(eventName,data);
    }
};

zss_editor.funpinListen = function(){
    var _this = this;

    //历史版本
    this.undoManager.init();

    //监听任务框的完成
    this.listenTodo();

    //监听键盘的敲击删除
    this.listenDelete();

    var $editorBody = $(_EDITOR_BODY);

    //禁用所有a标签的默认事件
    $editorBody.on("click tap","a",function(event){
        event.preventDefault();
    });

    //对于不可编辑区域的点击
    $editorBody.on("tap",function(event){
        if(event.target.isContentEditable === false){
            var $media = $(event.target).closest("[contenteditable=\"false\"]");
            $media = $media.length > 0 ? $media : $(event.target);

            if($media.length > 0){
                event.preventDefault();
                var div = null;
                var next = $media.get(0).nextSibling;

                if(next && _this.isEmptyLine(next)){
                    div = next;
                }else{
                    //在不可编辑的media之后放一行
                    // 创建空的dom节点
                    div = document.createElement("div");
                    var br = document.createElement('br');
                    br.setAttribute('data-mce-bogus',1);
                    div.appendChild(br);
                    $media.get(0).parentNode.insertBefore(div,next);
                }

                var _range = document.createRange();
                    _range.setStart(div, 0);
                    _range.setEnd(div, 0);

                    var selection = window.getSelection();
                    selection.removeAllRanges();
                    selection.addRange(_range);
            }
        }
    });

    //黏贴，通知原生端(IOS)
    $editorBody.on("paste",function(event){
        if(/iphone/i.test(navigator.userAgent)){
            event.preventDefault();
            _this.dispatch("paste");
        }
    });

    //当用户点出了可编辑区域(IOS)
    $("#zss_editor_footer").on("tap",function(){
        var div = null;
        var next = $editorBody.get(0).lastChild;

        if(next){
            if(_this.isEmptyLine(next)){
                div = next;
            }else{
                // 创建空的dom节点
                div = document.createElement("div");
                var br = document.createElement('br');
                br.setAttribute('data-mce-bogus',1);
                div.appendChild(br);
                next.parentNode.insertBefore(div,next.nextSibling);
            }
        }else{
            // 创建空的dom节点
            div = document.createElement("div");
            var br = document.createElement('br');
            br.setAttribute('data-mce-bogus',1);
            div.appendChild(br);
            document.body.appendChild(div);
        }

        var _range = document.createRange();
            _range.setStart(div, 0);
            _range.setEnd(div, 0);

            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(_range);
    });

};

//接受原生端剪贴板事件
zss_editor.onPaste = function(pasteData){
    console.log(pasteData);
};

zss_editor.isEmptyLine = function(node){
    if(!node) return false;

    return $(node.firstChild).is("br") || $(node).html() == "&nbsp;";
};


//监听编辑的删除键
zss_editor.listenDelete = function(){

    $(_EDITOR_BODY).on("keydown",function(event){
        if(event.keyCode == '8'){

            var sel = window.getSelection();
            if(sel.rangeCount > 0){
                var range = sel.getRangeAt(0);

                //删到了一个节点的开头
                if(range.collapsed && range.startOffset == 0){
                    var $prev = $(range.startContainer).prev();

                    if($prev.length == 0){
                        $prev = $(range.startContainer.parentNode).prev();
                    }

                    if($prev.length > 0 && ($prev.attr("contenteditable") == "false" || $prev.get(0).tagName == "IMG") ){
                        $prev.remove();
                    }
                }
            }

        }
    });
};


/**
 * 键盘的开闭处理,调整可编辑区域的高度(IOS)
 */
zss_editor.onKeyboardHide = function(){

    //键盘在被关闭时，IOS contentoffset会被置为0，所以这里将其还原
    //为了减少可见的闪动，将透明度进行渐变
    var onHideTop = document.body.scrollTop;
    document.body.style.opacity = 0;
    document.body.style.transition = "opacity 1s";
    setTimeout(function(){
        document.body.style.opacity = "";
        document.body.style.transition = "";
        document.body.scrollTop = onHideTop;
    },0);

    
};

zss_editor.onKeyboardShow = function(){
    console.log('show');
    console.log(document.body.scrollTop);
};

/**
 * 监听媒体(音频视频)处理有关
 * 
 */
zss_editor.listenMedia = function() {
    $("body").on("tap click touchstart", ".media a", function (event) {
        event.preventDefault();
    });

    //点击播放语音
    $("body").on("tap", ".media a[data-media]", function (event) {
        // event.preventDefault();
        // var media = $(this).data("media");

        // if (media) {
        //     //无协议开头，本地文件
        //     if (media.match(/^\//) && location.protocol == "file:") {
        //         media = "file://" + media;
        //     }

        //     //如果点击的是媒体文件
        //     var type = $(this).data("type");

        //     var $mediaDiv = $(this).closest(".media");

        //     //音频文件
        //     if (/audio/.test(type)) {

        //         //如果正在播放则将其暂停
        //         if (AudioPlayer.isPlaying(media)) {
        //             AudioPlayer.pause();

        //             $mediaDiv.removeClass("playing");
        //         } else {
        //             $mediaDiv.addClass("loading");

        //             AudioPlayer.play(media, function (status) {
        //                 switch (status) {
        //                     case "playing":
        //                     case "timeupdate":
        //                     case "loadedmetadata":
        //                         $mediaDiv.addClass("playing").removeClass("loading");
        //                         break;
        //                     case "ended":
        //                     case "pause":
        //                         $mediaDiv.removeClass("playing");
        //                         break;
        //                     case "error":
        //                         $mediaDiv.removeClass("loading").addClass("error").removeClass("playing");
        //                         break;
        //                 };
        //             });
        //         }
        //     }
        // } else {
        //     alert("无媒体文件url");
        // }
    });

    //点击重试翻译语音
    $("body").on("tap", ".media .res a", function () {

        //如果没有网络链接
        // if (!navigator.onLine) {}

        // if (_bridge) {
        //     var $media = $(this).closest(".media");
        //     var url = $media.find("a[data-media]").data("src") || $media.find("a[data-media]").data("media");

        //     if (url && !$media.hasClass("translating")) {

        //         //加上正在翻译标识
        //         $media.addClass("translating");

        //         var $res = $media.find(".res");
        //         //记录转换成功之前的状态文案，之后失败的时候放回
        //         $res.data("html", $res.html());
        //         //文案反馈加上
        //         $res.html("正在努力的为您转换语音...");

        //         _bridge.callHandler('translateVoice', { url: url }, function (responseData) {
        //             //成功
        //             console.log(responseData);
        //         });
        //     } else {
        //         alert("没找到url");
        //     }
        // } else {
        //     alert("bridge还没准备好");
        // }
    });
}

/**
 * 监听任务完成状态的变化
 */
zss_editor.listenTodo = function(){

    $(document.body).on("touchstart", ".todo-item", function (event) {
        //根据字体大小确定可点击的范围
        //fontsize_level: {"12px": 1,"16px": 2,"18px": 3,"22px": 4,"28px": 5}
        var xMax = 18,
            yMax = 23;
        if ($(this).hasClass('font-size-1')) {
            xMax = 15, yMax = 17;
        } else if ($(this).hasClass('font-size-2')) {
            xMax = 18, yMax = 23;
        } else if ($(this).hasClass('font-size-3')) {
            xMax = 20, yMax = 26;
        } else if ($(this).hasClass('font-size-4')) {
            xMax = 24, yMax = 32;
        } else if ($(this).hasClass('font-size-5')) {
            xMax = 30, yMax = 41;
        }

        if (!$(event.target).hasClass('todo-item')) xMax = 1;

        if (event.originalEvent) event = event.originalEvent;
        var offsetX = event.offsetX || event.layerX || event.changedTouches[0].pageX - this.offsetLeft;
        var offsetY = event.offsetY || event.layerY || event.changedTouches[0].pageY - this.offsetTop;

        if (offsetX <= xMax && offsetY <= yMax) {
            event.preventDefault();
        }
    });

    $(document.body).on("tap",".todo-item",function(event){
        //根据字体大小确定可点击的范围
        //fontsize_level: {"12px": 1,"16px": 2,"18px": 3,"22px": 4,"28px": 5}
        var xMax = 18,
            yMax = 23;
        if ($(this).hasClass('font-size-1')) {
            xMax = 15, yMax = 17;
        } else if ($(this).hasClass('font-size-2')) {
            xMax = 18, yMax = 23;
        } else if ($(this).hasClass('font-size-3')) {
            xMax = 20, yMax = 26;
        } else if ($(this).hasClass('font-size-4')) {
            xMax = 24, yMax = 32;
        } else if ($(this).hasClass('font-size-5')) {
            xMax = 30, yMax = 41;
        }

        if (!$(event.target).hasClass('todo-item')) xMax = 1;

        if (event.originalEvent) event = event.originalEvent;

        var offsetX = event.offsetX || event.layerX || event.changedTouches[0].pageX - this.offsetLeft;
        var offsetY = event.offsetY || event.layerY || event.changedTouches[0].pageY - this.offsetTop;

        if (offsetX <= xMax && offsetY <= yMax) {
            if ($(this).hasClass("done")) {
                $(this).removeClass("done");
            } else {
                $(this).addClass("done");
            }
        }

        //Android
        if(window.RE && $.isFunction(RE.callback)) RE.callback();
    });
}

DomUtil = {
    getSelectedNodes: function () {
        var nodes = [];
        var sel = window.getSelection();
        if (sel.rangeCount > 0) {
            nodes = DomUtil.getBlocksInRange(sel.getRangeAt(0));
        }

        return nodes;
        // var sel = window.getSelection();
        // var range = sel.getRangeAt(0);

        // // 通过extract得到range中的所有节点
        // var frag = range.extractContents();
        // var nodes = frag.querySelectorAll("*");

        // // 恢复所有节点
        // range.insertNode(frag);

        // // 恢复选区
        // sel.removeAllRanges();
        // sel.addRange(range);
        // return nodes;
    },
    
    isTextNode: function (node) {
        // 判断是否全都是文本节点,如果是，则无需遍历其子节点
        var isAllTextNode = true;

        if (node.childNodes.length > 0) {
            for (var i=0; i<node.childNodes.length; i++) {
                if (node.childNodes[i].nodeName !== "#text") {
                    isAllTextNode = false;
                    break;
                }
            }
        }
        return isAllTextNode;
    },

    getNextNode: function(node) {
        if (node.firstChild) {
            return node.firstChild;
        }

        while (node) {
            if (node.nextSibling)
                return node.nextSibling;
            node = node.parentNode;
        }
    },

    getNodesInRange: function(range) {
        var start = range.startContainer;
        var end = range.endContainer;
        var commonAncestor = range.commonAncestorContainer;
        var nodes = [];
        var node;

        // walk parent nodes from start to common ancestor
        for (node = start.parentNode; node; node = node.parentNode) {
            if (nodes.indexOf(node) < 0){
                var isroot = node.getAttribute && node.getAttribute("contenteditable") == "true";
                
                if (!isroot) {
                    nodes.push(node);
                }
            }
            if (node === commonAncestor)
                break;
        }

        nodes.reverse();

        var shouldInclude;
        // walk children and siblings from start until end is found
        for (node = start; node; node = DomUtil.getNextNode(node)) {
            shouldInclude = true;
            // 过滤文本节点
            if (node.nodeName === "#text") {
                // 空或换行
                if (!node.nodeValue || node.nodeValue === "\n") {
                    shouldInclude = false;
                // 已经被包含的文本
                } else if (nodes[nodes.length - 1] && nodes[nodes.length - 1].contains(node)){
                    shouldInclude = false;
                }
            }

            if (shouldInclude && nodes.indexOf(node) < 0) {
                nodes.push(node);
            }

            if (node == end)
                break;
        }

        return nodes;
    },

    // 找到自己所处的block
    getOwnBlock: function(node) {
        var tmpNode = node;
        while(!DomUtil.isBlock(tmpNode) && !DomUtil.isTextBlock(tmpNode)){
            tmpNode = tmpNode.parentNode;
        }

        return tmpNode;
    },

    getBlocksInRange: function(range) {
        var start = range.startContainer;
        var end = range.endContainer;
        var commonAncestor = range.commonAncestorContainer;
        var nodes = [];
        var node;

        if (start === commonAncestor) {
            // 是根节点
            if (start.getAttribute && start.getAttribute("contenteditable") === "true") {
                if (start !== end) {
                    start = start.childNodes[0];
                } else {
                    return [start];
                }
            } else {

            }
        }

        // walk parent nodes from start to common ancestor
        for (node = start.parentNode; node; node = node.parentNode) {
            var isroot = node.getAttribute && node.getAttribute("contenteditable") == "true";

            if (nodes.indexOf(node) < 0){
                if (!isroot) {
                    nodes.push(node);
                }
            }
            if (node === commonAncestor || isroot)
                break;
        }

        nodes.reverse();
        console.log("parent", nodes);
        var shouldInclude;
        // walk children and siblings from start until end is found
        for (node = start; node; node = DomUtil.getNextNode(node)) {
            shouldInclude = true;

            // 过滤文本节点
            if (!DomUtil.isBlock(node) && !DomUtil.isTextBlock(node)) {
                // 已经被包含的文本
                if (nodes[nodes.length - 1] && nodes[nodes.length - 1] != node && nodes[nodes.length - 1].contains(node)){
                    shouldInclude = false;
                // 找到自己的块级元素
                } else {
                    var tmpNode = DomUtil.getOwnBlock(node);
                    if (tmpNode) {
                        // 如果自己的块级元素是顶层，则不处理
                        if (tmpNode.getAttribute("contenteditable")) {

                        } else {
                            shouldInclude = false;
                            nodes.push(tmpNode);
                        }
                    }
                }
            }

            if (shouldInclude &&
             node.nodeValue &&
             node.nodeValue !== "\n" &&
             nodes.indexOf(node) < 0) {
                nodes.push(node);
            }

            if (node == end)
                break;
        }

        return nodes;
    },

    //得到选区中的block和textBlock
    getSelectedVisualBlocks: function(nodes){
        if(!nodes) nodes = DomUtil.getSelectedNodes();
        var blocks = [];
        console.log("nodes", nodes);

        var node = null;
        for (var i=0,len=nodes.length; i<len; i++) {
            node = nodes[i];

            if(!node) continue;

            //如果其中包含块级节点
            if(DomUtil.containsBlock(node)){
                //得到其中的textBlock
                var textBlocks = DomUtil.textBlockInNode(node);

                if(textBlocks.length > 0){
                    blocks = blocks.concat(textBlocks);
                }
                continue;
            }else if(DomUtil.textBlockInNode(node).length > 1){
                //节点中包含多个换行文本,则分开处理
                var childBlocks = this.getSelectedVisualBlocks(node.childNodes);

                if(childBlocks.length > 0){
                    blocks = blocks.concat(childBlocks);
                }
            }else{
                //处理块级元素或者换行文本
                if(DomUtil.isBlock(node)){
                    if(blocks.indexOf(node) < 0) blocks.push(node);
                }else if(DomUtil.isTextBlock(node)){
                    if(blocks.indexOf(node) < 0 && !$(node).is('br') ){
                        blocks.push(node);
                    }
                }else{
                    if($(node).is('br')){
                        continue;
                    }

                    // 将所有内联放一块
                    var div = document.createElement('div');

                    if(node){
                        node.parentNode.insertBefore(div,node);
                        var newNode = node.nextSibling;

                        div.appendChild(node);

                        if(newNode){
                            while(newNode && !DomUtil.isTextBlock(newNode)){
                                div.appendChild(newNode);
                                newNode = newNode.nextSibling;

                                i++;
                            }

                            if(newNode){
                                div.appendChild(newNode);
                                i++;
                            }
                        }

                        if(blocks.indexOf(node) < 0) blocks.push(div);
                    }
                }
            }
        };

        //不存在选区中的block移除
        var selection = window.getSelection(),_this = this;
        if(selection.containsNode){
            $(blocks).each(function(i,blockNode){
                // if(!selection.containsNode(blockNode) && !_this.hasChildNodeInSelection(blockNode,selection)){
                //selection不包含blockNode的任何东西，则去除
                if(!selection.containsNode(blockNode,true)){
                    blocks.splice(i,1);
                }
            });
        }

        return blocks;
    },

    //判断某个dom节点是否是文本换行
    isTextBlock: function(node){
        if(!node) return false;
        if($(node).is('br')) return false;
        return !this.isBlock(node) 
                && ( $(node).next().is('br') ||
                $(node).find('br,div').length > 0 ||
                $(node).is('img') ||
                this.isBlock(node.nextSibling) );
    },

    isBlockTag: function(tag){
        var cStyle,
        t = document.createElement(tag),
        gcs = "getComputedStyle" in window;

        document.body.appendChild(t);
        cStyle = (gcs ? window.getComputedStyle(t, "") : t.currentStyle).display; 
        document.body.removeChild(t);

        return cStyle == "block" || cStyle == "list-item";
    },

    //判断某个dom节点是否是block元素
    isBlock: function(node){
        if(!node || !node.tagName) return false;
        var display = $(node).css('display');
        return display == 'block' || display == 'list-item';
    },

    //判断某个节点是否包含有block(或textBlock)
    containsBlock: function(node){
        var containsBlock = false;
        var _this = this;
        if(node){
            $(node.childNodes).each(function(){
                if(_this.isBlock(this)){
                    containsBlock = true;
                    return false;
                }
            });
        }

        return containsBlock;
    },

    //判断某个节点是否包含有block(或textBlock)
    textBlockInNode: function(node){
        var blocks = [];
        var _this = this;
        if(node){
            $(node.childNodes).each(function(){
                if(_this.isTextBlock(this)){
                    blocks.push(this);
                }
            });
        }

        return blocks;
    },

    //在指定位置分割list，并在指定位置放入新的节点如果第三个参数给定的话
    splitList: function(listNode,breakNode,newList){
        if(listNode){

            var breakPoint = listNode.childNodes.length;

            var firstList = document.createElement(listNode.tagName);
            var secondList = null;

            listNode.parentNode.insertBefore(firstList,listNode);
            if(newList) listNode.parentNode.insertBefore(newList,listNode);

            $(listNode.childNodes).each(function(i,node){
                if(node != breakNode && !$.contains(node,breakNode)){
                    if( i < breakPoint ){
                        firstList.appendChild(node);
                    }else{
                        if(!secondList){
                            secondList = document.createElement(listNode.tagName);
                            listNode.parentNode.insertBefore(secondList,listNode);
                        }
                        secondList.appendChild(node);
                    }
                }else{
                    breakPoint = i;
                    if(!secondList){
                        secondList = document.createElement(listNode.tagName);
                        listNode.parentNode.insertBefore(secondList,listNode);
                    }
                    secondList.appendChild(node);
                }
            });

            if(firstList && firstList.childNodes.length == 0){
                $(firstList).remove();
            }

            if(secondList && secondList.childNodes.length == 0){
                $(secondList).remove();
            }

            $(listNode).remove();

            return [firstList,secondList,newList];
        }
    },

    wrapNode: function(node, wrap) {
        node.parentNode.insertBefore(wrap, node);

        wrap.appendChild(node);
    },

    //将节点最外层去除,即将子节点全部拿出来
    //例子: <div>dsddsdsd<span>dsd</span></div> -> dsddsdsd<span>dsd</span>
    unwrapNode: function(node){
        if(!node) return;

        if(node.childNodes.length > 0){
            $(node.childNodes).each(function(){
                node.parentNode.insertBefore(this,node);
            });

            $(node).remove();
        }
    },

    splitNode: function(node, breakNode, breakOffset) {
        var parent = node.parentNode;
        var parentOffset = this.getNodeIndex(parent, node);

        var doc = breakNode.ownerDocument;  
        var leftRange = doc.createRange();
        leftRange.setStart(parent, parentOffset);
        leftRange.setEnd(breakNode, breakOffset);

        var left = leftRange.extractContents();
        var newLi = left.childNodes[0];
        parent.insertBefore(left, node);

        return newLi;
    },

    getNodeIndex: function(parent, node) {
        var index = parent.childNodes.length;
        while (index--) {
            if (node === parent.childNodes[index]) {
                break;
            }
        }
        return index;
    },

    insertList: function(listtype, blockEls){
        var _this = this;
        listtype = listtype || 'ul';
        var tag = listtype == 'todo' ? 'ul' : listtype;

        if (!blockEls) {
            var blockEls = DomUtil.getSelectedVisualBlocks() || [];

            //选区中没得到块级选区
            if(blockEls.length == 0){
                var range = window.getSelection().getRangeAt(0);

                var isroot = range.startContainer.getAttribute && range.startContainer.getAttribute("contenteditable") === "true";

                if(!isroot) blockEls.push(range.startContainer)
            }
        }

        // 如果选中块为空
        if (blockEls.length === 0) {
            return false;
        }

        //在拆分某个已经存在list时保存被拆分的所有list,最后将此lists种的空list删除
        var allLists = null,lastLi = null;

        var list = document.createElement(tag);
        $(blockEls).each(function(i,blockEl){
            if(blockEl){
                if(i == 0){
                    var insideList = $(this).closest('ul').get(0) || $(this).closest('ol').get(0);

                    if(insideList){
                        allLists = DomUtil.splitList(insideList,blockEl,list);
                    }else{
                        this.parentNode.insertBefore(list,this);
                    }
                }

                //将blockEl变成任务li.todo-item
                if(this.tagName && this.tagName == 'LI'){
                    lastLi = this;
                } else if($(this).closest('li').length > 0){
                    lastLi = $(this).closest('li').get(0);
                } else{
                    //如果是textBlock记得将br去除
                    if(DomUtil.isTextBlock(this)){
                        if($(this).next().is("br")){
                            $(this).next().remove();
                        }
                    }
                    lastLi = document.createElement('li');
                    lastLi.appendChild(this);
                }

                if(listtype == 'todo'){
                    $(lastLi).addClass('todo-item');
                }

                // 如果li中只有一个div元素包着子元素,不然回车时不能形成新的li
                if (lastLi.childNodes.length === 1 &&
                    lastLi.childNodes[0].tagName === "DIV") {
                    DomUtil.unwrapNode(lastLi.childNodes[0]);
                }

                list.appendChild(lastLi);
            }
        });

        //拆分list后，子list中的空list全部删除
        if(allLists){
            $(allLists).each(function(i, _list){
                if(_list && _list.childNodes.length == 0){
                    $(_list).remove();
                }
            });
        }

        return list;
    },
};

// 设置选区
zss_editor.setRange = function(start, soffset, end, eoffset) {
    var editor = $(_EDITOR_BODY).get(0);

    if(!editor.contains(start) ||
        !editor.contains(end)) {
        console.error("编辑器中不包含range中的节点", start, end);
        return false;
    }

    var sel = window.getSelection();
    sel.removeAllRanges();
    try {
        var newRange = document.createRange();
        newRange.setStart(start, soffset);
        newRange.setEnd(end, eoffset);
        sel.addRange(newRange);
    } catch(e) {
        console.log("setRange Error", start, soffset, end, eoffset);
    }
    
};

// 插入任务
zss_editor.insertTodo = function () {
    var range = window.getSelection().getRangeAt(0);
    var sc = range.startContainer,
        so = range.startOffset,
        ec = range.endContainer,
        eo = range.endOffset;

    $(_EDITOR_BODY).trigger("beforeinput");

    // 空div创建todo
    if (sc === ec &&
         sc.tagName === "DIV" &&
         $("*", sc).length === 1 &&
        $("*", sc).is("br")) {
        var newSc = sc.childNodes[0];
        sc = ec = newSc;
    }

    // 得到被选中的块级元素
    var blockEls = DomUtil.getSelectedVisualBlocks();

    // 为避免range改变这里还原range
    zss_editor.setRange(sc, so, ec, eo);

    // 没有得到选中的块级元素
    if(blockEls.length === 0){
        var isroot = range.startContainer.getAttribute && range.startContainer.getAttribute("contenteditable");

        if (isroot) {
            document.execCommand('insertUnorderedList', false, null);

            blockEls.push($(_EDITOR_BODY).find("li").get(0));
        } else {
            blockEls.push(range.startContainer);
        }
    } else if (blockEls.length === 1 && blockEls[0] === $(_EDITOR_BODY).get(0)) {
        document.execCommand('insertUnorderedList', false, null);

        blockEls = [$(_EDITOR_BODY).find("li").get(0)];
    }

    // 判断是否所有选中的都已经是todo
    var isAlreadyTodo = true;
    $(blockEls).each(function(){
        if(!$(this).hasClass("todo-item") &&
            $(this).closest('li.todo-item').length == 0){
            isAlreadyTodo = false;
            return false;
        }
    });

    // 如果已经是todo, 则去除所有todo属性
    if (isAlreadyTodo) {
        var tempDiv = document.createElement('div');

        $(blockEls).each(function(i){
            // 针对第一个选中的元素做处理, 第0个元素决定新的节点的开始位置
            // -1
            // 0
            // 1
            // 2
            // 3
            if(i == 0){
                var insideList = $(this).closest('ul').get(0) || $(this).closest('ol').get(0);

                // 如果在列表元素中，则将其拆开
                if(insideList){
                    DomUtil.splitList(insideList,this,tempDiv);
                }else{
                    this.parentNode.insertBefore(tempDiv,this);
                }
            }



            //找到任务li
            var todoItem = $(this).hasClass("todo-item") ? this : $(this).closest('li.todo-item').get(0);

            //将任务li中的所有子节点移出
            if(todoItem){
                var nodes = $(todoItem).contents();

                var tempDiv2 = document.createElement('div');

                $(nodes).each(function(){
                    tempDiv2.appendChild(this);
                });

                tempDiv.appendChild(tempDiv2);

                //如果包含块级元素则将子节点都拿出来
                if(DomUtil.containsBlock(tempDiv2)){
                    DomUtil.unwrapNode(tempDiv2);
                }

                //移除li
                $(todoItem).remove();

            }
        });

        DomUtil.unwrapNode(tempDiv);
    // 否则转为todo
    } else {
        DomUtil.insertList("todo", blockEls);
    }

    // 去除空的ul,li
    $(_EDITOR_BODY).find("ul, li.todo-item").each(function () {
        if ( !$.trim($(this).html()) ) {
            $(this).remove();
        }
    });

    // 恢复选区
    zss_editor.setRange(sc, so, ec, eo);

    $(_EDITOR_BODY).trigger("input");
};

// 在当前位置插入有序列表
zss_editor.insertUl = function () {
    $(_EDITOR_BODY).trigger("beforeinput");

    var range = window.getSelection().getRangeAt(0);
    var sc = range.startContainer,
        so = range.startOffset,
        ec = range.endContainer,
        eo = range.endOffset;

    document.execCommand('insertUnorderedList', false, null);

    var sel = window.getSelection();
    sel.removeAllRanges();
    var newRange = document.createRange();
    newRange.setStart(sc, so);
    newRange.setEnd(ec, eo);
    sel.addRange(newRange);
};

// 在当前位置插入无序列表
zss_editor.insertOl = function () {
    $(_EDITOR_BODY).trigger("beforeinput");

    var range = window.getSelection().getRangeAt(0);
    var sc = range.startContainer,
        so = range.startOffset,
        ec = range.endContainer,
        eo = range.endOffset;

    console.log("插入无序列表");
    document.execCommand('insertOrderedList', false, null);

    var sel = window.getSelection();
    sel.removeAllRanges();
    var newRange = document.createRange();
    newRange.setStart(sc, so);
    newRange.setEnd(ec, eo);
    sel.addRange(newRange);
};

//undoManager
zss_editor.undoManager = {

    _timer: null,

    getEditor: function(){
        return window.RE ? window.RE : (window.zss_editor || {});
    },

    //初始化
    init: function(){
        var _this = this;

        //当前的位置
        this._bookmarkID = 0;

        //此次编辑会话的所有版本历史
        this._bookmarks = [];

        //添加第一个bookmark
        $(_EDITOR_BODY).off("keydown.funpin beforeinput").on("keydown.funpin beforeinput",function(){
            if(_this._bookmarks.length == 0){
                _this.add();    
            }
        });

        //监听变化
        $(_EDITOR_BODY)
            .off("input.funpin keyup.funpin change.funpin paste.funpin")
            .on("input.funpin keyup.funpin change.funpin paste.funpin",function(event){

            if(_this._timer){
                clearTimeout(_this._timer);
            }

            //延时添加bookmark
            _this._timer = setTimeout(function(){
                var currentHtml = _this.getEditor().getHTML();
                var lastHtml = _this._bookmarks[this._bookmarkID];

                if(currentHtml != _this.getTrueLastHtml(lastHtml)){
                    _this.add();
                }

                //保存
                zss_editor.dispatch("saveContent");
            },1000);

        });
    },


    getTrueLastHtml: function(lastHtml){
        if(lastHtml){
            lastHtml.replace("<cur></cur>","");
        };
        return lastHtml;
    },


    // 在记录数组的时候   
    // 把光标位置用  插入cur标签
    insertCurDom: function(){
        var sel = document.getSelection();
        var range = sel.getRangeAt(0);

        //获取光标位置，然后把光标 插入到自定义标签 cur中
        var cur = document.createElement('cur');
        if(range.collapsed){
            range.insertNode(cur);

        }else{
            var sc = range.startContainer,
                so = range.startOffset,
                ec = range.endContainer,
                eo = range.endOffset;

            sel.collapseToEnd();
            range.insertNode(cur);

            var newRange = document.createRange();
            newRange.setStart(sc, so);
            newRange.setEnd(ec, eo);
            sel = window.getSelection();
            sel.removeAllRanges();
            sel.addRange(newRange);
        }       
        
    },

    // 删除占位标签
    removeCurDom: function(){
        var $cur = $(_EDITOR_BODY).find('cur');
            $cur.remove(); 
    },

    //还原光标 找到dom中的cur标签  
    //把光标放过去 然后把cur标签删除掉
    restoreCursor: function(){

        var $cur = $(_EDITOR_BODY).find('cur');
        var range = document.createRange();
        range.setStartAfter($cur.get(0));//在cur标签后面
        range.setEndAfter($cur.get(0));//在cur标签后面
        range.collapse(false);

        var selection = window.getSelection();
        
        selection.removeAllRanges();
        selection.addRange(range);

        // this.removeCurDom();
    },


    //增加历史
    add: function(){

        //如果当前不在bookmarks的最前方，则现将之前的redo历史去除，再进行添加
        var redoLen = this._bookmarks.length - (1 + this._bookmarkID);
        if(redoLen > 0){
            this._bookmarks.splice(this._bookmarkID + 1, redoLen);
        }

        this.insertCurDom();

        var html = this.getEditor().getHTML() || "";

        this._bookmarkID = this._bookmarks.push(html) - 1;

        this.removeCurDom();
    },

    //撤回
    undo: function(){
        var currentBookmarkID = this._bookmarkID;
        
        if(currentBookmarkID > 0){

            var prevBookmarkID = currentBookmarkID - 1;
            
            if(typeof this._bookmarks[prevBookmarkID] == "string"){
                var html = this._bookmarks[prevBookmarkID];

                //放入html
                this.getEditor().setHTML(html);

                this.restoreCursor();

                this._bookmarkID = prevBookmarkID;

                //Android
                if(window.RE && $.isFunction(RE.callback)) RE.callback();
            }
        }
    },

    //重做
    redo: function(){

        var currentBookmarkID = this._bookmarkID;

        if(currentBookmarkID >= 0){

            var nextBookmarkID = currentBookmarkID + 1;

            if(typeof this._bookmarks[nextBookmarkID] == "string"){
                var html = this._bookmarks[nextBookmarkID];

                //放入html
                this.getEditor().setHTML(html);

                this.restoreCursor();

                this._bookmarkID = nextBookmarkID;

                //Android
                if(window.RE && $.isFunction(RE.callback)) RE.callback();
            }
        }

    },

    //通知原生，编辑历史改变
    notify: function(){
        zss_editor.dispatch("edit_history_change",{
            current: this._bookmarkID,
            length: this._bookmarks.length
        });
    }

};



//重写编辑器的undo方法(IOS)
zss_editor.undo = function(){
    this.undoManager.undo();
};


//重写编辑器的redo方法(IOS)
zss_editor.redo = function(){
    this.undoManager.redo();
};

//insertHTML命令之后的操作
zss_editor.postInsertHTML = function(html){
    //commend insertHTML 会去除一些特殊的属性，例如contenteditable，这里需要恢复
    $("#zss_editor_content .media").attr("contenteditable","false");
}

//通知原生端程序
zss_editor.dispatch = function(message,data){

    var dataJSON = "";

    try{
        var payload = {
            message: message,
            data: data
        };
        dataJSON = JSON.stringify(payload);
    }catch(e){

    }

    window.location = "funpin://"+encodeURIComponent(dataJSON);
};

/**
 * --------- 来自方片收集的添加结束 ----------
 */



zss_editor.funpinListen();
